#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2700one4xi.py">
#<abstract4xi abstract = "fires to direction one and to distance 2700"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2700one4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

       
# -------------------------------------------------------------------------------------------------
# SHOT2ONE - COORDINATE SIGNS OF SHOOT2ONE4XI: (X + ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------  

global shot2one27004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings - copied from load2one4xi.py results to access faster by verb4xi.py
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False 


 
                         
# -------------------------------------------------------------------------------------------------
# 2700
# -------------------------------------------------------------------------------------------------                                          
shot2one27004xi = {
                  1:'0x0y2699z',
                  2:'0x1787y2023z',
                  3:'0x81y2698z',
                  4:'101x88y2696z',
                  5:'1036x1036y2267z',
                  6:'1047x2064y1389z',
                  7:'1058x2187y1176z',
                  8:'1067x1523y1956z',
                  9:'1071x965y2282z',
                  10:'1081x1801y1695z',
                  11:'1103x893y2296z',
                  12:'1129x820y2310z',
                  13:'1133x1450y1975z',
                  14:'1147x1994y1412z',
                  15:'1164x1728y1716z',
                  16:'1165x2118y1200z',
                  17:'116x112y2695z',
                  18:'1194x1374y1993z',
                  19:'122x2415y1200z',
                  20:'1242x1919y1435z',
                  21:'1243x1651y1737z',
                  22:'1251x1295y2011z',
                  23:'1268x2044y1224z',
                  24:'128x137y2693z',
                  25:'12x323y2680z',
                  26:'1302x1214y2029z',
                  27:'1316x1570y1757z',
                  28:'1332x1840y1458z',
                  29:'1348x1131y2047z',
                  30:'1366x1965y1248z',
                  31:'1384x1486y1778z',
                  32:'1389x1047y2064z',
                  33:'138x165y2691z',
                  34:'1417x1756y1481z',
                  35:'1425x961y2082z',
                  36:'1447x1399y1798z',
                  37:'1459x1881y1272z',
                  38:'146x193y2689z',
                  39:'1497x1668y1503z',
                  40:'1505x1310y1818z',
                  41:'150x223y2686z',
                  42:'152x253y2683z',
                  43:'152x285y2680z',
                  44:'153x328y2776z',
                  45:'1548x1792y1296z',
                  46:'1557x1218y1838z',
                  47:'155x2239y1499z',
                  48:'1572x1577y1526z',
                  49:'15x22y2699z',
                  50:'1604x1124y1858z',
                  51:'1630x1699y1319z',
                  52:'1641x1482y1548z',
                  53:'1704x1384y1570z',
                  54:'1707x1602y1343z',
                  55:'1762x1284y1592z',
                  56:'1778x1502y1366z',
                  57:'178x2038y1761z',
                  58:'182x1737y2058z',
                  59:'1844x1399y1389z',
                  60:'210x2497y1003z',
                  61:'247x2393y1224z',
                  62:'26x295y2683z',
                  63:'270x1704y2076z',
                  64:'270x2213y1522z',
                  65:'282x2009y1781z',
                  66:'28x45y2699z',
                  67:'2x27y2699z',
                  68:'339x2473y1028z',
                  69:'354x1668y2093z',
                  70:'370x2365y1248z',
                  71:'383x1973y1801z',
                  72:'383x2181y1544z',
                  73:'38x2259y1477z',
                  74:'38x266y2686z',
                  75:'39x70y2698z',
                  76:'3x54y2699z',
                  77:'435x1626y2110z',
                  78:'466x2441y1053z',
                  79:'47x238y2689z',
                  80:'47x96y2697z',
                  81:'482x1933y1821z',
                  82:'491x2330y1272z',
                  83:'493x2143y1566z',
                  84:'513x1581y2127z',
                  85:'52x209y2691z',
                  86:'53x124y2696z',
                  87:'55x151y2695z',
                  88:'55x180y2693z',
                  89:'577x1888y1841z',
                  90:'588x1532y2143z',
                  91:'591x2403y1078z',
                  92:'600x2099y1588z',
                  93:'609x2288y1296z',
                  94:'658x1480y2159z',
                  95:'668x1837y1861z',
                  96:'704x2049y1610z',
                  97:'712x2359y1102z',
                  98:'724x2241y1319z',
                  99:'725x1424y2175z',
                  100:'72x2062y1740z',
                  101:'756x1783y1880z',
                  102:'788x1365y2191z',
                  103:'79x2515y978z',
                  104:'804x1994y1631z',
                  105:'831x2308y1127z',
                  106:'835x2187y1343z',
                  107:'840x1724y1900z',
                  108:'846x1303y2207z',
                  109:'85x66y2697z',
                  110:'900x1239y2222z',
                  111:'901x1935y1653z',
                  112:'920x1661y1919z',
                  113:'92x1764y2041z',
                  114:'943x2128y1366z',
                  115:'946x2250y1151z',
                  116:'950x1173y2238z',
                  117:'993x1870y1674z',
                  118:'995x1105y2253z',
                  119:'996x1594y1938z'}

#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2700one4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2700one4xi(queue2one, consumer_channel2one, publisher_channel2one):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2700ONE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2700ONE4XI -  QUEUE2ONE: ", queue2one)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2700ONE4XI -  CONSUMER_CHANNEL2ONE: ", consumer_channel2one)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2700ONE4XI -  PUBLISHER_CHANNEL2ONE: ", publisher_channel2one)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2700ONE4XI - TRYING TO RETURN BY PUTTING SHOT2ONE27004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2one.put(shot2one27004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2700ONE4XI - SUCCEEDED TO PUT SHOT2ONE27004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
            # SUCCEEDED TO PUT SHOT2ONE27004XI TO QUEUE2ONE:  <queue4xi.Queue4Xi object at 0x02AF7090>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2700ONE4XI *** FAILED TO PUT SHOT2ONE27004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2700ONE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi())
        #
         
    if ack2put is True:
        message2send4one = "<ack2put4xi>queue2one8shot2one27004xi</ack2put4xi>"
    else:
        message2send4one = "<nack2put4xi>queue2one8shot2one27004xi</nack2put4xi>" 
            
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
         
        publisher_channel2one.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2700ONE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
            # SENT MESSAGE2SEND4ONE:  <ack2put4xi>queue2one8shot2one27004xi</ack2put4xi>  TO PUBLISHER_CHANNEL2ONE:  <read-write PipeConnection, handle 260>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time
        
    except:
        print(" (STEP 3C/33) OF FIRE2700ONE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2700ONE4XI - RETURNING QUEUE OBJECT QUEUE2ONE: ", queue2one, " - TIME: ", time4xi())  
        # 
            
    return queue2one    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2700one4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
